local WallAddition = ...

-- Register new material for the wall texture
WallAddition:register({
	DataType = "MATERIAL",
	Id = "MATERIAL_SGWALL",
	HasAlphaTest = false,
	AlbedoTexture = "RockWalls.png"
})

-- Register new material for the wall top texture
WallAddition:register({
	DataType = "MATERIAL",
	Id = "MATERIAL_SGWALL_TOP",
	HasAlphaTest = false,
	AlbedoTexture = "CastleRockTextureTestVersion2.png"
})

function registerWall(_wallbxName, _wallAssetId, _crenationDistance, _deltaHeight)
-- Register crenation model asset
WallAddition:registerAssetId("models/walls/" .. _wallbxName .. ".fbx/Prefab", "SGWALL_CRENATION_" .. _wallAssetId .. "_PREFAB")

-- Register the wall asset
WallAddition:register({
	DataType = "WALL_CONFIG",
	Id = "SGWALL_" .. _wallAssetId,
	WallConfigName = "SGWALL_" .. _wallAssetId .. "_NAME",
	IsManuallyUnlocked = false,
	Material = "MATERIAL_SGWALL",
	MaterialTop = "MATERIAL_SGWALL_TOP",
	Crenation = "SGWALL_CRENATION_" .. _wallAssetId .. "_PREFAB",
	CrenationDistance = _crenationDistance,
	StepLength = 4,
	Width = 2,
	Height = _deltaHeight,
	UvTillingWall = 0.28,
	UvTillingTop = 0.28,
	WallOffsetY = 0,
	CrenationOffsetY = 1.25 + _deltaHeight,
	CrenationOffsetZ = 0.18
})
end

registerWall( "crenationSimple", "SIMPLE", 1.8, 4.85 )
registerWall( "crenationHoardings", "HOARDINGS", 7.17, 7.16 )
registerWall( "crenationMachicolation", "MACHICOLATION", 1.8, 12 )
registerWall( "crenationWoodenMachicolation", "WOODEN_MACHICOLATION", 1.8, 12 )
registerWall( "crenationTiledMachicolation", "TILED_MACHICOLATION", 1.8, 12 )
